package btree.visitor;
import btree.*;

public class ToString implements IBTreeAlgo {
  
  public static final ToString Singleton = new ToString();
  private ToString(){}
  
  public Object mtCase(IMTBTree host, Object...nu) {
    return "[]";
  }
  
  public Object neCase(INEBTree host, Object...nu){
    Object[] data = host.getData();
    String result = "["+data[0];
    for(int i=1; i<data.length; i++) result += ", "+data[i];
    result += "]\n";
    
    IBTree[] children = host.getChildren();
    
    for(int i=0; i<data.length; i++){
      result += children[i].execute(_HelperAlgo, " | ");
    }
    result += children[data.length].execute(_HelperAlgo, "   ");
    return result;
  }
  
  private static final IBTreeAlgo _HelperAlgo = new IBTreeAlgo() {
    public Object mtCase(IMTBTree host, Object...params) {
      return " |_[]\n";
    }
    
    public Object neCase(INEBTree host, Object...params){
      String prefix = (String) params[0];
      Object[] data = host.getData();
      String result = " |_["+data[0];
      for(int i=1; i<data.length; i++) result += ", "+data[i];
      result += "]\n";
      
      IBTree[] children = host.getChildren();
      
      for(int i=0; i<data.length; i++){
        result += prefix+children[i].execute(_HelperAlgo, prefix+" | ");
      }
      result += prefix+children[data.length].execute(_HelperAlgo, prefix+"   ");
      return result;
    }
    
  };
  
}