package patient;

/**
 * An abstract algorithm on a Patient that depends on the state of the Patient.
 */
public interface IPatientVisitor
{
    /**
  * This method is called when the Patient is in its sane state.
  * @param host The Patient host.
  * @param param A generic input parameter.
  * @return The return value of the algorithm.
  */
 public Object saneCase(Patient host, Object... param);
    /**
  * This method is called when the Patient is in its insane state.
  * @param host The Patient host.
  * @param param A generic input parameter.
  * @return The return value of the algorithm.
  */
 public Object insaneCase(Patient host, Object... param);
}