package patient;
import java.util.*;

/**
 * This class represents the lack of a patient.   This is a singleton object.
 * 
 */
public class NullPatient implements IPatient
{
 /**
  * Singleton instance
  */
 public static final NullPatient Singleton = new NullPatient();

 /**
  * Private constructor, not to be called by clients.
  * 
  */
 private NullPatient()
 {
 }


 /**
  * Returns "No sane patient found!".
  */
 public String toString()
 {
  return("No sane patient!");
 }

 /**
  * Does nothing.
  * 
  */
 public void update(Observable o, Object param)
 {
 }

 /**
  * Does nothing.
  * 
  * @param algo ignored.
  * @param param ignored.
  * @return null always.
  */
 public Object execute(IPatientVisitor algo, Object... param)
 {
  return null;
 }

}