package rac;
import lrs.*;

/**
 * A fast "put" but slow "get" queue implementation.
 */
public class LRSQueue2Factory extends ALRSRACFactory {
  /**
   * Create a ``first-in, first-out'' (FIFO) container.
   */
  public IRAContainer makeRAC() {
    return new LRSRAContainer(new IAlgo() {
      public Object emptyCase(LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        return host.insertFront(input[0]);
      }
      
      public Object nonEmptyCase(LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        return host.insertFront(input[0]);
      }
    }, new IAlgo() {
      public Object emptyCase(LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        throw new IllegalStateException("Attempt to get data when RAC is empty!");
      }
      
      public Object nonEmptyCase(LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        return host.getRest().execute(new IAlgo() {
          public Object emptyCase(LRStruct h, Object...prev){
            return prev[0];
          }
          public Object nonEmptyCase(LRStruct h, Object...prev){
            return h.getRest().execute(this, h);
          }
        }, host);
      }
    });
    
  }    
}