package rac;
import lrs.*;

/**
 * A fast "get" but slow "get" queue implementation.
 */
public class LRSQueueFactory extends ALRSRACFactory {
  /**
   * Create a ``first-in, first-out'' (FIFO) container.
   */
  public IRAContainer makeRAC() {
    return new LRSRAContainer(new IAlgo() {
      public Object emptyCase(LRStruct host, Object... input) {
        return host.insertFront(input[0]);
      }
      
      public Object nonEmptyCase(LRStruct host, Object... input) {
        return host.getRest().execute(this, input);
      }
    },new IAlgo() {
      public Object emptyCase(LRStruct host, Object... input) {
        throw new IllegalStateException("Attempt to get data when RAC is empty!");
      }
      
      public Object nonEmptyCase(LRStruct host, Object... input) {
        return host;
      }
    });
    
  }    
}