package view;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import util.*;
import rac.*;
import patient.*;
import listFW.*;
import listFW.factory.*;

/**
 * The main application frame
 */
public class AppFrame extends AFrame {
  
  private JTextArea displayTA;
  private Dispatcher dispatcher = new Dispatcher();
  private IRAContainer raCont;
  private IRACFactory racFac;
  private IListAlgo toStringAlgo = new IListAlgo() {
    public Object emptyCase(IMTList host, Object... inp){
      return "";
    }
    public Object nonEmptyCase(INEList host, Object... inp){
      return host.getFirst()+"\n"+host.getRest().execute(this);
    }
  };
  
  private Thread timer = new Thread(){
    public void run()
    {
      while(true)
      {
        try
        {
          displayTA.setText((String)raCont.elements(CompositeListFactory.Singleton).execute(toStringAlgo));
          dispatcher.notifyAll(null);
          Thread.sleep(100);
        }
        catch(Exception e){}
      }
    }
  };
  
  
  public AppFrame(WindowListener wl) {
    super("TAMU", wl);
    
    timer.start();
  }
  
  
  protected void initialize() {
    racFac = new TAMUFactory();
    raCont = racFac.makeRAC();
    
    JPanel jPanel1 = new JPanel();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JScrollPane jScrollPane1 = new JScrollPane();
    JButton retrieveBtn = new JButton();
    JButton storeBtn = new JButton();
    JLabel titleLbl = new JLabel();
    final JLabel outputLbl = new JLabel();
    displayTA = new JTextArea();
    
    this.setSize(new Dimension(450, 500));
    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setLayout(gridLayout1);
    gridLayout1.setRows(-1);
    gridLayout1.setColumns(1);
    retrieveBtn.setText("Release Patient");
    retrieveBtn.addActionListener(new java.awt.event.ActionListener()
                                    {
      public void actionPerformed(ActionEvent e)
      {
          IPatient p = (IPatient) raCont.get();
          dispatcher.deleteObserver(p);
          outputLbl.setText(p.toString());
      }
    });
    storeBtn.setText("Admit Patient");
    storeBtn.addActionListener(new java.awt.event.ActionListener()
                                 {
      public void actionPerformed(ActionEvent e)
      {
        Patient p = new Patient();
        dispatcher.addObserver(p);
        raCont.put(p);
      }
    });
    titleLbl.setFont(new java.awt.Font("Dialog", 1, 18));
    titleLbl.setForeground(Color.red);
    titleLbl.setText("Texas Asylum for the Mentally Unstable");
    outputLbl.setPreferredSize(new Dimension(41, 20));
    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jPanel2, null);
    jPanel2.add(titleLbl, null);
    jPanel1.add(jPanel3, null);
    jPanel3.add(storeBtn, null);
    jPanel3.add(retrieveBtn, null);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(displayTA, null);
    this.getContentPane().add(outputLbl, BorderLayout.SOUTH);
    
  }
}