package brs.visitor;
import brs.*;

/**
 * Counts the number of data elements in a BiTRee.
 */
public class CountBRS implements IVisitor {
  public static final CountBRS Singleton = new CountBRS();
  private CountBRS(){}

  public Object emptyCase(BiTree host, Object... nu){
    return 0;
  }


  public Object nonEmptyCase(BiTree host, Object... nu){

    return 1 + (Integer) host.getLeftSubTree().execute(this) 
      + (Integer) host.getRightSubTree().execute(this);
  }
}

